// uni2jhojo.h

#ifndef UNI2JHOJO_H
#define UNI2JHOJO_H



///////////////////////////////////////////////////////////////////////////////////////
//                            UNICODE --> JIS 0212 (HOJO)
///////////////////////////////////////////////////////////////////////////////////////



static const unsigned short Uni2jhojoTable_00 [] = {
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x000x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x001x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x002x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x003x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x004x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x005x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x006x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x007x
      0,       0,       0,       0,       0,       0,       0x2237,  0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x008x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x009x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0x2242,  0,       0,       0,       0,       0x2243,  0,       // 0x00Ax
      0,       0x226D,  0x226C,  0,       0,       0,       0x226E,  0x2234,  
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x00Bx
      0x2231,  0,       0x226B,  0,       0,       0,       0,       0,       
      0x2A22,  0x2A21,  0x2A24,  0x2A2A,  0x2A23,  0x2A29,  0x2921,  0x2A2E,  // 0x00Cx
      0x2A32,  0x2A31,  0x2A34,  0x2A33,  0x2A40,  0x2A3F,  0x2A42,  0x2A41,  
      0,       0x2A50,  0x2A52,  0x2A51,  0x2A54,  0x2A58,  0x2A53,  0,       // 0x00Dx
      0x292C,  0x2A63,  0x2A62,  0x2A65,  0x2A64,  0x2A72,  0x2930,  0x294E,  
      0x2B22,  0x2B21,  0x2B24,  0x2B2A,  0x2B23,  0x2B29,  0x2941,  0x2B2E,  // 0x00Ex
      0x2B32,  0x2B31,  0x2B34,  0x2B33,  0x2B40,  0x2B3F,  0x2B42,  0x2B41,  
      0x2943,  0x2B50,  0x2B52,  0x2B51,  0x2B54,  0x2B58,  0x2B53,  0,       // 0x00Fx
      0x294C,  0x2B63,  0x2B62,  0x2B65,  0x2B64,  0x2B72,  0x2950,  0x2B73,  
} ;




///////////////////////////////////////////////////////////////////////////////////////
//                           Shift JIS --> JIS 0212 (HOJO)
///////////////////////////////////////////////////////////////////////////////////////


#define  Sjis2jhojoTable_80  NULL
#define  Sjis2jhojoTable_81  NULL
#define  Sjis2jhojoTable_82  NULL
#define  Sjis2jhojoTable_83  NULL
#define  Sjis2jhojoTable_84  NULL
#define  Sjis2jhojoTable_85  NULL
#define  Sjis2jhojoTable_86  NULL

static const unsigned short Sjis2jhojoTable_87 [] = {
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x874x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x875x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x876x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x877x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0x2271,  0,       0,       0,       0,       0,       // 0x878x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x879x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x87Ax
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x87Bx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x87Cx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x87Dx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x87Ex
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0x87Fx
      0,       0,       0,       0,       0,       0,       0,       0,       
} ;

#define  Sjis2jhojoTable_88  NULL
#define  Sjis2jhojoTable_89  NULL
#define  Sjis2jhojoTable_8A  NULL
#define  Sjis2jhojoTable_8B  NULL
#define  Sjis2jhojoTable_8C  NULL
#define  Sjis2jhojoTable_8D  NULL
#define  Sjis2jhojoTable_8E  NULL
#define  Sjis2jhojoTable_8F  NULL
#define  Sjis2jhojoTable_90  NULL
#define  Sjis2jhojoTable_91  NULL
#define  Sjis2jhojoTable_92  NULL
#define  Sjis2jhojoTable_93  NULL
#define  Sjis2jhojoTable_94  NULL
#define  Sjis2jhojoTable_95  NULL
#define  Sjis2jhojoTable_96  NULL
#define  Sjis2jhojoTable_97  NULL
#define  Sjis2jhojoTable_98  NULL
#define  Sjis2jhojoTable_99  NULL
#define  Sjis2jhojoTable_9A  NULL
#define  Sjis2jhojoTable_9B  NULL
#define  Sjis2jhojoTable_9C  NULL
#define  Sjis2jhojoTable_9D  NULL
#define  Sjis2jhojoTable_9E  NULL
#define  Sjis2jhojoTable_9F  NULL
#define  Sjis2jhojoTable_A0  NULL
#define  Sjis2jhojoTable_A1  NULL
#define  Sjis2jhojoTable_A2  NULL
#define  Sjis2jhojoTable_A3  NULL
#define  Sjis2jhojoTable_A4  NULL
#define  Sjis2jhojoTable_A5  NULL
#define  Sjis2jhojoTable_A6  NULL
#define  Sjis2jhojoTable_A7  NULL
#define  Sjis2jhojoTable_A8  NULL
#define  Sjis2jhojoTable_A9  NULL
#define  Sjis2jhojoTable_AA  NULL
#define  Sjis2jhojoTable_AB  NULL
#define  Sjis2jhojoTable_AC  NULL
#define  Sjis2jhojoTable_AD  NULL
#define  Sjis2jhojoTable_AE  NULL
#define  Sjis2jhojoTable_AF  NULL
#define  Sjis2jhojoTable_B0  NULL
#define  Sjis2jhojoTable_B1  NULL
#define  Sjis2jhojoTable_B2  NULL
#define  Sjis2jhojoTable_B3  NULL
#define  Sjis2jhojoTable_B4  NULL
#define  Sjis2jhojoTable_B5  NULL
#define  Sjis2jhojoTable_B6  NULL
#define  Sjis2jhojoTable_B7  NULL
#define  Sjis2jhojoTable_B8  NULL
#define  Sjis2jhojoTable_B9  NULL
#define  Sjis2jhojoTable_BA  NULL
#define  Sjis2jhojoTable_BB  NULL
#define  Sjis2jhojoTable_BC  NULL
#define  Sjis2jhojoTable_BD  NULL
#define  Sjis2jhojoTable_BE  NULL
#define  Sjis2jhojoTable_BF  NULL
#define  Sjis2jhojoTable_C0  NULL
#define  Sjis2jhojoTable_C1  NULL
#define  Sjis2jhojoTable_C2  NULL
#define  Sjis2jhojoTable_C3  NULL
#define  Sjis2jhojoTable_C4  NULL
#define  Sjis2jhojoTable_C5  NULL
#define  Sjis2jhojoTable_C6  NULL
#define  Sjis2jhojoTable_C7  NULL
#define  Sjis2jhojoTable_C8  NULL
#define  Sjis2jhojoTable_C9  NULL
#define  Sjis2jhojoTable_CA  NULL
#define  Sjis2jhojoTable_CB  NULL
#define  Sjis2jhojoTable_CC  NULL
#define  Sjis2jhojoTable_CD  NULL
#define  Sjis2jhojoTable_CE  NULL
#define  Sjis2jhojoTable_CF  NULL
#define  Sjis2jhojoTable_D0  NULL
#define  Sjis2jhojoTable_D1  NULL
#define  Sjis2jhojoTable_D2  NULL
#define  Sjis2jhojoTable_D3  NULL
#define  Sjis2jhojoTable_D4  NULL
#define  Sjis2jhojoTable_D5  NULL
#define  Sjis2jhojoTable_D6  NULL
#define  Sjis2jhojoTable_D7  NULL
#define  Sjis2jhojoTable_D8  NULL
#define  Sjis2jhojoTable_D9  NULL
#define  Sjis2jhojoTable_DA  NULL
#define  Sjis2jhojoTable_DB  NULL
#define  Sjis2jhojoTable_DC  NULL
#define  Sjis2jhojoTable_DD  NULL
#define  Sjis2jhojoTable_DE  NULL
#define  Sjis2jhojoTable_DF  NULL
#define  Sjis2jhojoTable_E0  NULL
#define  Sjis2jhojoTable_E1  NULL
#define  Sjis2jhojoTable_E2  NULL
#define  Sjis2jhojoTable_E3  NULL
#define  Sjis2jhojoTable_E4  NULL
#define  Sjis2jhojoTable_E5  NULL
#define  Sjis2jhojoTable_E6  NULL
#define  Sjis2jhojoTable_E7  NULL
#define  Sjis2jhojoTable_E8  NULL
#define  Sjis2jhojoTable_E9  NULL
#define  Sjis2jhojoTable_EA  NULL
#define  Sjis2jhojoTable_EB  NULL
#define  Sjis2jhojoTable_EC  NULL
#define  Sjis2jhojoTable_ED  NULL
#define  Sjis2jhojoTable_EE  NULL
#define  Sjis2jhojoTable_EF  NULL
#define  Sjis2jhojoTable_F0  NULL
#define  Sjis2jhojoTable_F1  NULL
#define  Sjis2jhojoTable_F2  NULL
#define  Sjis2jhojoTable_F3  NULL
#define  Sjis2jhojoTable_F4  NULL
#define  Sjis2jhojoTable_F5  NULL
#define  Sjis2jhojoTable_F6  NULL
#define  Sjis2jhojoTable_F7  NULL
#define  Sjis2jhojoTable_F8  NULL
#define  Sjis2jhojoTable_F9  NULL

static const unsigned short Sjis2jhojoTable_FA [] = {
      0x7321,  0x7322,  0x7323,  0x7324,  0x7325,  0x7326,  0x7327,  0x7328,  // 0xFA4x
      0x7329,  0x732A,  0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0x7335,  0x7336,  // 0xFA5x
      0,       0,       0,       0,       0x5463,  0x5C5F,  0x6469,  0x6378,  
      0x5921,  0x313B,  0x733A,  0x422D,  0x437C,  0x6450,  0x423F,  0x3C74,  // 0xFA6x
      0x3029,  0x3048,  0x733B,  0x3052,  0x3054,  0x3063,  0x306E,  0x3127,  
      0x3123,  0x312C,  0x3129,  0x313E,  0x315F,  0x3158,  0x3148,  0x3157,  // 0xFA7x
      0x3163,  0x3174,  0x3161,  0x3223,  0x733C,  0x323B,  0x3266,  0,       
      0x326D,  0x3275,  0x327C,  0x733D,  0x3335,  0x3358,  0x335B,  0x3365,  // 0xFA8x
      0x336E,  0x337B,  0x733E,  0x733F,  0x3440,  0x3447,  0x3450,  0x345E,  
      0x7340,  0x352A,  0x7341,  0x352F,  0x3544,  0x3568,  0x7342,  0x3742,  // 0xFA9x
      0x3764,  0x3768,  0x3767,  0x7343,  0x7344,  0x7345,  0x384E,  0x3861,  
      0x3875,  0x3877,  0x3878,  0x387C,  0x392F,  0x3937,  0x3A3E,  0x3A5B,  // 0xFAAx
      0x4D2A,  0x3A61,  0x7346,  0x3A6B,  0x3B33,  0x3B38,  0x7347,  0x3B4A,  
      0x7348,  0x7349,  0x3B50,  0x3B5E,  0x3B74,  0x3B75,  0x3B79,  0x3C64,  // 0xFABx
      0x3C6D,  0x3C7E,  0x734A,  0x3D42,  0x3D67,  0x734B,  0x3D70,  0x3E30,  
      0x3E2C,  0x734C,  0x3E33,  0x3E3D,  0x3E4D,  0x3E49,  0x3E64,  0x3F28,  // 0xFACx
      0x3F49,  0x4044,  0x4064,  0x4074,  0x4126,  0x734D,  0x4175,  0x417C,  
      0,       0x4178,  0x422B,  0x4221,  0x4225,  0x734F,  0x4238,  0x423A,  // 0xFADx
      0x7350,  0x4244,  0x4252,  0x4257,  0x425B,  0x425E,  0x426D,  0x4270,  
      0x7351,  0x4321,  0x4335,  0x4349,  0x4339,  0x7352,  0x4358,  0x437E,  // 0xFAEx
      0x7353,  0x444C,  0x7354,  0x4459,  0x446A,  0x447D,  0x7355,  0x4527,  
      0x4535,  0x4536,  0x7356,  0x4555,  0x4638,  0x4657,  0x4660,  0x466A,  // 0xFAFx
      0x4663,  0x4721,  0x472B,  0x4747,  0x4743,  0,       0,       0,       
} ;


static const unsigned short Sjis2jhojoTable_FB [] = {
      0x474B,  0x474F,  0x4759,  0x7357,  0x7358,  0x4766,  0x476E,  0x477C,  // 0xFB4x
      0x476B,  0x4770,  0x4831,  0x4865,  0x4878,  0x4926,  0x492B,  0x492D,  
      0x7359,  0x494A,  0x4953,  0x4969,  0x4963,  0x497C,  0x4974,  0x4975,  // 0xFB5x
      0x735A,  0x4A33,  0x4A3D,  0x4A6F,  0x4A71,  0x4B2E,  0x735B,  0x4B4A,  
      0x4B66,  0x4B6A,  0x4B70,  0x4B74,  0x4B6E,  0x4C25,  0x4B79,  0x4C2B,  // 0xFB6x
      0x4C2E,  0x4C2D,  0x4C32,  0x4C42,  0x4C50,  0x4C59,  0x735C,  0x4D3B,  
      0x735D,  0x4E3B,  0x735E,  0x4E3A,  0x4E43,  0x735F,  0x4E72,  0x335D,  // 0xFB7x
      0x4F55,  0x4F62,  0x4F69,  0x4F6D,  0x7360,  0x7361,  0x7362,  0,       
      0x7363,  0x5065,  0x7364,  0x5069,  0x5168,  0x7365,  0x7366,  0x516C,  // 0xFB8x
      0x523B,  0x7367,  0x5361,  0x5368,  0x5427,  0x7368,  0x7369,  0x5454,  
      0x5472,  0x552E,  0x736A,  0x575E,  0x736B,  0x5822,  0x5837,  0x5841,  // 0xFB9x
      0x5851,  0x5874,  0x5946,  0x5948,  0x5951,  0x736C,  0x736D,  0x736E,  
      0x736F,  0x7370,  0x5C53,  0x5D48,  0x5D54,  0x5D6A,  0x5D7A,  0x5E24,  // 0xFBAx
      0x5E30,  0x7371,  0x5E35,  0x5E4B,  0x7372,  0x5F39,  0x7373,  0x5F43,  
      0x7374,  0x7375,  0x6059,  0x7376,  0x7377,  0x6162,  0x7378,  0x7379,  // 0xFBBx
      0x737A,  0x6247,  0x6328,  0x6326,  0x6329,  0x632F,  0x6330,  0x632A,  
      0x632B,  0x633C,  0x6341,  0x633F,  0x6355,  0x6358,  0x6356,  0x635F,  // 0xFBCx
      0x6363,  0x6361,  0x6354,  0x6369,  0x6426,  0x6371,  0x6372,  0x644B,  
      0x6441,  0x6443,  0x643E,  0x737B,  0x6440,  0x6447,  0x643F,  0x6460,  // 0xFBDx
      0x645E,  0x6451,  0x737C,  0x645C,  0x6452,  0x645B,  0x6454,  0x647A,  
      0x646F,  0x6533,  0x653F,  0x6549,  0x6550,  0x6562,  0x656A,  0x656B,  // 0xFBEx
      0x737D,  0x737E,  0x7421,  0x6668,  0x666F,  0x672C,  0x7422,  0x672E,  
      0x7463,  0x6731,  0x7424,  0x6732,  0x6831,  0x6836,  0x7425,  0x7426,  // 0xFBFx
      0x685D,  0x7427,  0x7428,  0x6951,  0x7429,  0,       0,       0,       
} ;


static const unsigned short Sjis2jhojoTable_FC [] = {
      0x696D,  0x6A4D,  0x742A,  0x6A5B,  0x6A66,  0x6A6A,  0x6B25,  0x6B7B,  // 0xFC4x
      0x6B7A,  0x742B,  0x6C56,  0x742C,  0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xFC5x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xFC6x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xFC7x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xFC8x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xFC9x
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xFCAx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xFCBx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xFCCx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xFCDx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xFCEx
      0,       0,       0,       0,       0,       0,       0,       0,       
      0,       0,       0,       0,       0,       0,       0,       0,       // 0xFCFx
      0,       0,       0,       0,       0,       0,       0,       0,       
} ;

#define  Sjis2jhojoTable_FD  NULL
#define  Sjis2jhojoTable_FE  NULL
#define  Sjis2jhojoTable_FF  NULL


static const unsigned short *Sjis2jhojoTable ( int C ) {

   static const unsigned short *const Sjis2jhojoTable_80_FF [] = {
      Sjis2jhojoTable_80, Sjis2jhojoTable_81, Sjis2jhojoTable_82, Sjis2jhojoTable_83,
      Sjis2jhojoTable_84, Sjis2jhojoTable_85, Sjis2jhojoTable_86, Sjis2jhojoTable_87,
      Sjis2jhojoTable_88, Sjis2jhojoTable_89, Sjis2jhojoTable_8A, Sjis2jhojoTable_8B,
      Sjis2jhojoTable_8C, Sjis2jhojoTable_8D, Sjis2jhojoTable_8E, Sjis2jhojoTable_8F,

      Sjis2jhojoTable_90, Sjis2jhojoTable_91, Sjis2jhojoTable_92, Sjis2jhojoTable_93,
      Sjis2jhojoTable_94, Sjis2jhojoTable_95, Sjis2jhojoTable_96, Sjis2jhojoTable_97,
      Sjis2jhojoTable_98, Sjis2jhojoTable_99, Sjis2jhojoTable_9A, Sjis2jhojoTable_9B,
      Sjis2jhojoTable_9C, Sjis2jhojoTable_9D, Sjis2jhojoTable_9E, Sjis2jhojoTable_9F,

      Sjis2jhojoTable_A0, Sjis2jhojoTable_A1, Sjis2jhojoTable_A2, Sjis2jhojoTable_A3,
      Sjis2jhojoTable_A4, Sjis2jhojoTable_A5, Sjis2jhojoTable_A6, Sjis2jhojoTable_A7,
      Sjis2jhojoTable_A8, Sjis2jhojoTable_A9, Sjis2jhojoTable_AA, Sjis2jhojoTable_AB,
      Sjis2jhojoTable_AC, Sjis2jhojoTable_AD, Sjis2jhojoTable_AE, Sjis2jhojoTable_AF,

      Sjis2jhojoTable_B0, Sjis2jhojoTable_B1, Sjis2jhojoTable_B2, Sjis2jhojoTable_B3,
      Sjis2jhojoTable_B4, Sjis2jhojoTable_B5, Sjis2jhojoTable_B6, Sjis2jhojoTable_B7,
      Sjis2jhojoTable_B8, Sjis2jhojoTable_B9, Sjis2jhojoTable_BA, Sjis2jhojoTable_BB,
      Sjis2jhojoTable_BC, Sjis2jhojoTable_BD, Sjis2jhojoTable_BE, Sjis2jhojoTable_BF,

      Sjis2jhojoTable_C0, Sjis2jhojoTable_C1, Sjis2jhojoTable_C2, Sjis2jhojoTable_C3,
      Sjis2jhojoTable_C4, Sjis2jhojoTable_C5, Sjis2jhojoTable_C6, Sjis2jhojoTable_C7,
      Sjis2jhojoTable_C8, Sjis2jhojoTable_C9, Sjis2jhojoTable_CA, Sjis2jhojoTable_CB,
      Sjis2jhojoTable_CC, Sjis2jhojoTable_CD, Sjis2jhojoTable_CE, Sjis2jhojoTable_CF,

      Sjis2jhojoTable_D0, Sjis2jhojoTable_D1, Sjis2jhojoTable_D2, Sjis2jhojoTable_D3,
      Sjis2jhojoTable_D4, Sjis2jhojoTable_D5, Sjis2jhojoTable_D6, Sjis2jhojoTable_D7,
      Sjis2jhojoTable_D8, Sjis2jhojoTable_D9, Sjis2jhojoTable_DA, Sjis2jhojoTable_DB,
      Sjis2jhojoTable_DC, Sjis2jhojoTable_DD, Sjis2jhojoTable_DE, Sjis2jhojoTable_DF,

      Sjis2jhojoTable_E0, Sjis2jhojoTable_E1, Sjis2jhojoTable_E2, Sjis2jhojoTable_E3,
      Sjis2jhojoTable_E4, Sjis2jhojoTable_E5, Sjis2jhojoTable_E6, Sjis2jhojoTable_E7,
      Sjis2jhojoTable_E8, Sjis2jhojoTable_E9, Sjis2jhojoTable_EA, Sjis2jhojoTable_EB,
      Sjis2jhojoTable_EC, Sjis2jhojoTable_ED, Sjis2jhojoTable_EE, Sjis2jhojoTable_EF,

      Sjis2jhojoTable_F0, Sjis2jhojoTable_F1, Sjis2jhojoTable_F2, Sjis2jhojoTable_F3,
      Sjis2jhojoTable_F4, Sjis2jhojoTable_F5, Sjis2jhojoTable_F6, Sjis2jhojoTable_F7,
      Sjis2jhojoTable_F8, Sjis2jhojoTable_F9, Sjis2jhojoTable_FA, Sjis2jhojoTable_FB,
      Sjis2jhojoTable_FC, Sjis2jhojoTable_FD, Sjis2jhojoTable_FE, Sjis2jhojoTable_FF,
   } ;

   if ( C >= 0x80 && C <= 0xFF ) return Sjis2jhojoTable_80_FF [ C - 0x80 ] ;

   return NULL ;
}


#endif
