// viet.h

#ifndef VIET_H
#define VIET_H



typedef struct {
   int           cUnicode ;
   const wchar_t *szUnicode ;          // assi
   const wchar_t *szUnicodeAlt ;       // alternative
   const wchar_t *szUnicodeDecomp ;    // decomposed
   const char    *szVni ;              // vni
   const char    *szViqr ;             // viqr
   const char    *szViqrAlt ;          // viqr alt
} VIET_EQUIVALENT_TABLE ;



const VIET_EQUIVALENT_TABLE *UnicodeToViet ( const wchar_t *szSrc, size_t *pLength ) ;

const wchar_t *GetVniToUnicodeString ( int C ) ;

const VIET_EQUIVALENT_TABLE *ViqrStringToUnicode ( const char *szSrc, size_t *pLength ) ;
int IsViqrDiacritics ( int cUnicode ) ;

int GetUnicodeForTcvn2 ( int cUnicode, const wchar_t *szUnicode ) ;
int GetUnicodeForTcvn3 ( int cUnicode, const wchar_t *szUnicode ) ;



#endif


