// thread.cpp

#include <windows.h>
#include <process.h>
#include "msc.h"
#include "thread.h"


#ifdef _MT



static unsigned int WINAPI ThreadFunction ( void *pInitialData ) ;



// XbhN
//  0 As 0 ȊOԂ
// pHandle ɃXbh̃nhi[iKvłȂ NULL łj
// Xbh̃nh pHandle Ŏ擾AĂяo CloseHandle() ŕȂ΂ȂȂ
int BeginThread ( int ( *pFunction ) ( void *pInitialData ), void *pInitialData, HANDLE *pHandle ) {

   THREAD_DATA *pThreadData = AllocThreadData () ;
   if ( ! pThreadData ) return 1 ;

   pThreadData->pFunction = pFunction ;
   pThreadData->pInitialData = pInitialData ;

   unsigned int nTreadId ;

   HANDLE hThread = (HANDLE) _beginthreadex ( NULL, 0, ThreadFunction, (void*) pThreadData, 0, & nTreadId ) ;
   if ( hThread ) {
      if ( pHandle ) *pHandle = hThread ;
      else           CloseHandle ( hThread ) ;
      return 0 ;
   }
   else {
      if ( pHandle ) *pHandle = hThread ;
      FreeThreadData ( pThreadData ) ;
      return 1 ;
   }
}



static unsigned int WINAPI ThreadFunction ( void *pInitialData ) {

   THREAD_DATA *pThreadData = (THREAD_DATA*) pInitialData ;

   InitializeThreadData ( pThreadData ) ;

   int nResult = pThreadData->pFunction ( pThreadData->pInitialData ) ;

   FreeThreadData ( pThreadData ) ;

   return nResult ;
}



#endif


