// execute.cpp

#include <windows.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include "msc.h"
#include "execute.h"



#define CREATE_PROCESS_FLAGS  CREATE_DEFAULT_ERROR_MODE



//////////////////////////////
//          ANSI          //
//////////////////////////////



static int ExecuteInternalA ( char *szCmdLine, int nCmdShow, unsigned long dwTimeOut, int *pExitCode ) ;



// R}hsAw肳ꂽԂ܂ő҂iANSIŁj
// dwTimeOut ɂ̓~bA܂ INFINITE w肷
// R}hsłȂƂ 0 ȊO̐Ԃ
// Ԃ𒴉߂Ƃ͕Ԃ
// I pExitCode ɃG[R[hi[iKvłȂ NULL łj
// szCmdLine ̃R}h́A΃pXApXŎw肵Ă
// nCmdShow ́AevZXpƂ SW_SHOWDEFAULT Aw肵ȂȂ -1 w肷
int ExecuteA ( const char *szCmdLine, int nCmdShow, unsigned long dwTimeOut, int *pExitCode ) {

   if ( ! szCmdLine ) szCmdLine = "" ;

   char *szCmdLineBuffer = strdup_expand ( szCmdLine, (size_t) -1, 8 ) ;
   if ( ! szCmdLineBuffer ) return 1 ;

   int nResult = ExecuteInternalA ( szCmdLineBuffer, nCmdShow, dwTimeOut, pExitCode ) ;

   free ( szCmdLineBuffer ) ;
   return nResult ;
}



// ExecuteA ̉֐
//  szCmdLine ͔ const ŁAobt@̗̒͐]T
//  i CreateProcess ̑Q̐̂߁j
// ߂l ExecuteA Ɠ
static int ExecuteInternalA ( char *szCmdLine, int nCmdShow, unsigned long dwTimeOut, int *pExitCode ) {

   int nResult = 1 ;
   unsigned long nExitCode = 0 ;

   // Nݒ
   PROCESS_INFORMATION ProcessInfo = { 0 } ;
   STARTUPINFOA StartupInfo = { 0 } ;
   StartupInfo.cb = sizeof(STARTUPINFOA) ;

   if ( nCmdShow == SW_SHOWDEFAULT ) {
      STARTUPINFOA ParentInfo = { 0 } ;
      ParentInfo.cb = sizeof(STARTUPINFOA) ;
      GetStartupInfoA ( & ParentInfo ) ;
      if ( ParentInfo.dwFlags & STARTF_USESHOWWINDOW ) nCmdShow = ParentInfo.wShowWindow ;
      else                                             nCmdShow = -1 ;
   }
   if ( nCmdShow >= 0 && nCmdShow <= SW_MAX ) {
      StartupInfo.dwFlags |= STARTF_USESHOWWINDOW ;
      StartupInfo.wShowWindow = nCmdShow ;
   }

   // s
   if ( CreateProcessA ( NULL, szCmdLine, NULL, NULL, FALSE, CREATE_PROCESS_FLAGS, NULL, NULL, & StartupInfo, & ProcessInfo ) ) {

      CloseHandle ( ProcessInfo.hThread ) ;

      // ҋ@
      if ( dwTimeOut && WaitForSingleObject ( ProcessInfo.hProcess, dwTimeOut ) == WAIT_TIMEOUT ) nResult = -1 ;
      else                                                                                        nResult = 0 ;

      // G[R[h擾
      if ( pExitCode && dwTimeOut && ! nResult ) GetExitCodeProcess ( ProcessInfo.hProcess, & nExitCode ) ;

      CloseHandle ( ProcessInfo.hProcess ) ;
   }

   // G[R[hi[
   if ( pExitCode ) *pExitCode = nExitCode ;

   return nResult ;
}



// system() ̑֊֐iANSIŁj
// CRT̊ϐ𗘗pȂ
int ExecuteViaComspecA ( const char *szCmdLine ) {

   char szComspec [ MAX_PATH ] ;
   static const char szComspecOption [] = " /c " ;    // OɃXy[X
   int nExitCode ;
   int nResult ;

   // R}hC^v^擾
   nResult = GetEnvironmentVariableA ( "COMSPEC", szComspec, MAX_PATH ) ;
   if ( nResult <= 0 || nResult >= MAX_PATH ) {
      char *szTmp ;
      const char *szPredefinedComspec = ( IsNT () ) ? "CMD.EXE" : "COMMAND.COM" ;
      nResult = SearchPathA ( NULL, szPredefinedComspec, NULL, MAX_PATH, szComspec, & szTmp ) ;
      if ( nResult <= 0 || nResult >= MAX_PATH ) strcpy ( szComspec, szPredefinedComspec ) ;
   }

   if ( ! szCmdLine ) {
      unsigned long dwAttributes = GetFileAttributesA ( szComspec ) ;
      if ( dwAttributes != INVALID_FILE_ATTRIBUTES && ! ( dwAttributes & FILE_ATTRIBUTE_DIRECTORY ) ) return 1 ;
      errno = ENOENT ;
      return 0 ;
   }

   char *szCmdLineBuffer = (char*) malloc ( ( strlen ( szComspec ) + strlen ( szComspecOption ) + strlen ( szCmdLine ) + 8 ) * sizeof(char) ) ;
   if ( ! szCmdLineBuffer ) {
      errno = E2BIG ;
      return -1 ;
   }

   // R}hC쐬
   if ( strchr ( szComspec, 0x20 ) ) {
      strcpy ( szCmdLineBuffer, "\"" ) ;
      strcat ( szCmdLineBuffer, szComspec ) ;
      strcat ( szCmdLineBuffer, "\"" ) ;
   }
   else {
      strcpy ( szCmdLineBuffer, szComspec ) ;
   }

   strcat ( szCmdLineBuffer, szComspecOption ) ;

   // R}hɈpƂ́A"CMD.EXE /C" ̂Ƃ̕ŜɈpň͂
   if ( IsNT () && *szCmdLine == '\"' ) {
      strcat ( szCmdLineBuffer, "\"" ) ;
      strcat ( szCmdLineBuffer, szCmdLine ) ;
      strcat ( szCmdLineBuffer, "\"" ) ;
   }
   else {
      strcat ( szCmdLineBuffer, szCmdLine ) ;
   }

   // s
   nResult = ExecuteInternalA ( szCmdLineBuffer, -1, INFINITE, & nExitCode ) ;

   free ( szCmdLineBuffer ) ;

   if ( nResult > 0 ) {
      errno = ENOENT ;
      return -1 ;
   }

   return nExitCode ;
}



// R}hCŐ߂ł悤C
// buffer  NULL ȂΏ܂ɒvZ
// ԂiI[k܂ށj
size_t EncodeArgumentToCrtStyleA ( const char *szSrc, char *szDst ) {

   int IsAddQuote = strpbrk ( szSrc, " ,;=&\t" ) ? 1 : 0 ;
   char *szStart = szDst ;

   if ( IsAddQuote ) {
      if ( szStart ) *szDst ++ = '\"' ;
      else            szDst ++ ;
   }

   while ( *szSrc ) {

      if ( *szSrc == '\\' ) {
         int IsBackslashQuote = 0 ;
         for ( const char *p = szSrc ; p ; p ++ ) {
            if ( *p == '\"' || ! *p && IsAddQuote ) { IsBackslashQuote = 1 ; break ; }
            if ( *p != '\\' ) break ;
         }
         if ( IsBackslashQuote ) {
            while ( *szSrc == '\\' ) {
               if ( szStart ) *szDst ++ = *szSrc ++ ;
               else            szDst ++,   szSrc ++ ;
               if ( szStart ) *szDst ++ = '\\' ;
               else            szDst ++ ;
            }
            continue ;
         }
      }

      if ( *szSrc == '\"' ) {
         if ( szStart ) *szDst ++ = '\\' ;
         else            szDst ++ ;
      }

      if ( szStart ) *szDst ++ = *szSrc ++ ;
      else            szDst ++,   szSrc ++ ;
   }

   if ( IsAddQuote ) {
      if ( szStart ) *szDst ++ = '\"' ;
      else            szDst ++ ;
   }

   if ( szStart ) *szDst ++ = 0 ;
   else            szDst ++ ;

   return szDst - szStart ;
}



//////////////////////////////
//         UNICODE        //
//////////////////////////////



static int ExecuteInternalW ( wchar_t *szCmdLine, int nCmdShow, unsigned long dwTimeOut, int *pExitCode ) ;



// R}hsAw肳ꂽԂ܂ő҂iUNICODEŁj
// dwTimeOut ɂ̓~bA܂ INFINITE w肷
// R}hsłȂƂ 0 ȊO̐Ԃ
// Ԃ𒴉߂Ƃ͕Ԃ
// I pExitCode ɃG[R[hi[iKvłȂ NULL łj
// szCmdLine ̃R}h́A΃pXApXŎw肵Ă
// nCmdShow ́AevZXpƂ SW_SHOWDEFAULT Aw肵ȂȂ -1 w肷
int ExecuteW ( const wchar_t *szCmdLine, int nCmdShow, unsigned long dwTimeOut, int *pExitCode ) {

   if ( ! szCmdLine ) szCmdLine = L"" ;

   wchar_t *szCmdLineBuffer = wcsdup_expand ( szCmdLine, (size_t) -1, 8 ) ;

   int nResult = ExecuteInternalW ( szCmdLineBuffer, nCmdShow, dwTimeOut, pExitCode ) ;

   free ( szCmdLineBuffer ) ;
   return nResult ;
}



// ExecuteW ̉֐
//  szCmdLine ͔ const ŁAobt@̗̒͐]T
//  i CreateProcess ̑Q̐̂߁j
// ߂l ExecuteW Ɠ
static int ExecuteInternalW ( wchar_t *szCmdLine, int nCmdShow, unsigned long dwTimeOut, int *pExitCode ) {

   int nResult = 1 ;
   unsigned long nExitCode = 0 ;

   // Nݒ
   PROCESS_INFORMATION ProcessInfo = { 0 } ;
   STARTUPINFOW StartupInfo = { 0 } ;
   StartupInfo.cb = sizeof(STARTUPINFOW) ;

   if ( nCmdShow == SW_SHOWDEFAULT ) {
      STARTUPINFOW ParentInfo = { 0 } ;
      ParentInfo.cb = sizeof(STARTUPINFOW) ;
      GetStartupInfoW ( & ParentInfo ) ;
      if ( ParentInfo.dwFlags & STARTF_USESHOWWINDOW ) nCmdShow = ParentInfo.wShowWindow ;
      else                                             nCmdShow = -1 ;
   }
   if ( nCmdShow >= 0 && nCmdShow <= SW_MAX ) {
      StartupInfo.dwFlags |= STARTF_USESHOWWINDOW ;
      StartupInfo.wShowWindow = nCmdShow ;
   }

   // s
   if ( CreateProcessW ( NULL, szCmdLine, NULL, NULL, FALSE, CREATE_PROCESS_FLAGS, NULL, NULL, & StartupInfo, & ProcessInfo ) ) {

      CloseHandle ( ProcessInfo.hThread ) ;

      // ҋ@
      if ( dwTimeOut && WaitForSingleObject ( ProcessInfo.hProcess, dwTimeOut ) == WAIT_TIMEOUT ) nResult = -1 ;
      else                                                                                        nResult = 0 ;

      // G[R[h擾
      if ( pExitCode && dwTimeOut && ! nResult ) GetExitCodeProcess ( ProcessInfo.hProcess, & nExitCode ) ;

      CloseHandle ( ProcessInfo.hProcess ) ;
   }

   // G[R[hi[
   if ( pExitCode ) *pExitCode = nExitCode ;

   return nResult ;
}



// system() ̑֊֐iUNICODEŁj
// CRT̊ϐ𗘗pȂ
int ExecuteViaComspecW ( const wchar_t *szCmdLine ) {

   wchar_t szComspec [ MAX_PATH ] ;
   static const wchar_t szComspecOption [] = L" /c " ;      // OɃXy[X
   int nExitCode ;
   int nResult ;

   // R}hC^v^擾
   nResult = GetEnvironmentVariableW ( L"COMSPEC", szComspec, MAX_PATH ) ;
   if ( nResult <= 0 || nResult >= MAX_PATH ) {
      wchar_t *szTmp ;
      const wchar_t *szPredefinedComspec = ( IsNT () ) ? L"CMD.EXE" : L"COMMAND.COM" ;
      nResult = SearchPathW ( NULL, szPredefinedComspec, NULL, MAX_PATH, szComspec, & szTmp ) ;
      if ( nResult <= 0 || nResult >= MAX_PATH ) wcscpy ( szComspec, szPredefinedComspec ) ;
   }

   if ( ! szCmdLine ) {
      unsigned long dwAttributes = GetFileAttributesW ( szComspec ) ;
      if ( dwAttributes != INVALID_FILE_ATTRIBUTES && ! ( dwAttributes & FILE_ATTRIBUTE_DIRECTORY ) ) return 1 ;
      errno = ENOENT ;
      return 0 ;
   }

   wchar_t *szCmdLineBuffer = (wchar_t*) malloc ( ( wcslen ( szComspec ) + wcslen ( szComspecOption ) + wcslen ( szCmdLine ) + 8 ) * sizeof(wchar_t) ) ;
   if ( ! szCmdLineBuffer ) {
      errno = E2BIG ;
      return -1 ;
   }

   // R}hC쐬
   if ( wcschr ( szComspec, 0x20 ) ) {
      wcscpy ( szCmdLineBuffer, L"\"" ) ;
      wcscat ( szCmdLineBuffer, szComspec ) ;
      wcscat ( szCmdLineBuffer, L"\"" ) ;
   }
   else {
      wcscpy ( szCmdLineBuffer, szComspec ) ;
   }

   wcscat ( szCmdLineBuffer, szComspecOption ) ;

   // R}hɈpƂ́A"CMD.EXE /C" ̂Ƃ̕ŜɈpň͂
   if ( IsNT () && *szCmdLine == '\"' ) {
      wcscat ( szCmdLineBuffer, L"\"" ) ;
      wcscat ( szCmdLineBuffer, szCmdLine ) ;
      wcscat ( szCmdLineBuffer, L"\"" ) ;
   }
   else {
      wcscat ( szCmdLineBuffer, szCmdLine ) ;
   }

   // s
   nResult = ExecuteInternalW ( szCmdLineBuffer, -1, INFINITE, & nExitCode ) ;

   free ( szCmdLineBuffer ) ;

   if ( nResult > 0 ) {
      errno = ENOENT ;
      return -1 ;
   }

   return nExitCode ;
}



// R}hCŐ߂ł悤C
// buffer  NULL ȂΏ܂ɒvZ
// ԂiI[k܂ށj
size_t EncodeArgumentToCrtStyleW ( const wchar_t *szSrc, wchar_t *szDst ) {

   int IsAddQuote = wcspbrk ( szSrc, L" ,;=&\t" ) ? 1 : 0 ;
   wchar_t *szStart = szDst ;

   if ( IsAddQuote ) {
      if ( szStart ) *szDst ++ = '\"' ;
      else            szDst ++ ;
   }

   while ( *szSrc ) {

      if ( *szSrc == '\\' ) {
         int IsBackslashQuote = 0 ;
         for ( const wchar_t *p = szSrc ; p ; p ++ ) {
            if ( *p == '\"' || ! *p && IsAddQuote ) { IsBackslashQuote = 1 ; break ; }
            if ( *p != '\\' ) break ;
         }
         if ( IsBackslashQuote ) {
            while ( *szSrc == '\\' ) {
               if ( szStart ) *szDst ++ = *szSrc ++ ;
               else            szDst ++,   szSrc ++ ;
               if ( szStart ) *szDst ++ = '\\' ;
               else            szDst ++ ;
            }
            continue ;
         }
      }

      if ( *szSrc == '\"' ) {
         if ( szStart ) *szDst ++ = '\\' ;
         else            szDst ++ ;
      }

      if ( szStart ) *szDst ++ = *szSrc ++ ;
      else            szDst ++,   szSrc ++ ;
   }

   if ( IsAddQuote ) {
      if ( szStart ) *szDst ++ = '\"' ;
      else            szDst ++ ;
   }

   if ( szStart ) *szDst ++ = 0 ;
   else            szDst ++ ;

   return szDst - szStart ;
}



