// execute.h

#ifndef EXECUTE_H
#define EXECUTE_H

#ifdef __cplusplus
extern "C" {
#endif


int ExecuteA ( const char *szCmdLine, int nCmdShow, unsigned long dwTimeOut, int *pExitCode ) ;
int ExecuteW ( const wchar_t *szCmdLine, int nCmdShow, unsigned long dwTimeOut, int *pExitCode ) ;
int ExecuteViaComspecA ( const char *szCmdLine ) ;
int ExecuteViaComspecW ( const wchar_t *szCmdLine ) ;
size_t EncodeArgumentToCrtStyleA ( const char *szSrc, char *szDst ) ;
size_t EncodeArgumentToCrtStyleW ( const wchar_t *szSrc, wchar_t *szDst ) ;


#ifdef UNICODE
#define Execute ExecuteW
#define ExecuteViaComspec ExecuteViaComspecW
#define EncodeArgumentToCrtStyle EncodeArgumentToCrtStyleW
#else
#define Execute ExecuteA
#define ExecuteViaComspec ExecuteViaComspecA
#define EncodeArgumentToCrtStyle EncodeArgumentToCrtStyleA
#endif


#define system ExecuteViaComspecA
#define _wsystem ExecuteViaComspecW


#ifdef __cplusplus
}
#endif

#endif


