// ask.h

#ifndef ASK_H
#define ASK_H

#ifndef _WINDOWS

#ifdef __cplusplus
extern "C" {
#endif


int AskA ( const char *szMessage, int nType ) ;
int AskW ( const wchar_t *szMessage, int nType ) ;


#ifdef UNICODE
#define Ask AskW
#else
#define Ask AskA
#endif


#ifndef MB_OK
#define MB_OK 0x00000000L
#endif
#ifndef MB_OKCANCEL
#define MB_OKCANCEL 0x00000001L
#endif
#ifndef MB_YESNOCANCEL
#define MB_YESNOCANCEL 0x00000003L
#endif
#ifndef MB_YESNO
#define MB_YESNO 0x00000004L
#endif


#ifdef __cplusplus
}
#endif

#endif // _WINDOWS

#endif // ASK_H


