// nls.h

#ifndef NLS_H
#define NLS_H


#ifdef __cplusplus
extern "C" {
#endif


int CharsetToCodePage ( int nCharset ) ;
int CodePageToCharset ( int nCodePage ) ;
int IsMultiByteCharset ( int nCharset ) ;

int GetModelessCodePage ( int nCodePage ) ;
int GetWinCodePage ( int nCodePage ) ;

int IsMultiByteCodePage ( int nCodePage ) ;

int IsCodePageVietnamese ( int nCodePage ) ;
int IsMacCodePage ( int nCodePage ) ;
int IsTaiwanLegacyCodePage ( int nCodePage ) ;

int IsCodePageIscii ( int nCodePage ) ;
int IsCodePageTamil ( int nCodePage ) ;
int IsCodePageIndic ( int nCodePage ) ;

int IsCodePageEbcdic ( int nCodePage ) ;

int IsOsCodePageHkscs ( void ) ;
int IsValidCodePageHkscs ( void ) ;

int GetThreadACP ( void ) ;
int GetMacCP ( void ) ;

int CharsetToLangId ( int nCharset ) ;
int IsLangIdCjk ( int nLangId ) ;


#ifdef __cplusplus
}
#endif


#endif


