// uninorm.h

#ifndef UNINORM_H
#define UNINORM_H

#ifdef __cplusplus
extern "C" {
#endif


int NormalizeUnicodeCompatibility ( int cUnicode ) ;

const wchar_t *DecomposeUnicodePresentationForms ( int cUnicode ) ;
const wchar_t *DecomposeUnicodeCharacter ( int cUnicode ) ;

const wchar_t *DecomposeUnicodeHangul ( int cUnicode, wchar_t *szBuffer ) ;
int ComposeUnicodeHangul ( const wchar_t *szString, size_t *pLength ) ;

int NormalizeUnicodeWidthForms ( int cUnicode ) ;
int CjkRadicalsToCjk ( int cUnicode ) ;

int GetNonLinshiDaima ( int cUnicode ) ;
int GetLinshiDaima ( int cUnicode ) ;
int IsHaveLinshiDaima ( int cUnicode ) ;
int IsLinshiDaima ( int cUnicode ) ;
int IsLinshiDaimaGb18030 ( int cUnicode ) ;

int GetNuktaChar ( int C, int nCodePage ) ;
int GetNonNuktaChar ( int C, int nCodePage ) ;


#ifdef __cplusplus
}
#endif

#endif

