// conv_loaddll.h

#ifndef CONV_LOADDLL_H
#define CONV_LOADDLL_H


// for CHNCONV.EXECOM and RTFCONV.EXE/COM/DLL



////////////////////////////////////////
//              LOADDLL               //
////////////////////////////////////////



#ifdef __cplusplus
extern "C" {
#endif

HINSTANCE LoadDllA ( HINSTANCE hInstance, const char *szDllName ) ;
HINSTANCE LoadDllW ( HINSTANCE hInstance, const wchar_t *szDllName ) ;

#ifdef __cplusplus
}
#endif



#ifndef CONV_LOAD_GLOBAL
#define CONV_LOAD_GLOBAL(type,name)    extern type name
#endif



////////////////////////////////////////
//          RTFCONV.EXE/COM           //
////////////////////////////////////////
#if defined RTFCONV_EXE || defined RTFCONV_COM



#include "rtfconv.h"


#ifdef __cplusplus
extern "C" {
#endif

int LoadRtfconvDll ( void ) ;

CONV_LOAD_GLOBAL ( HINSTANCE, hRtfconv ) ;

CONV_LOAD_GLOBAL ( RTFCONVEXA, RtfconvExA ) ;
CONV_LOAD_GLOBAL ( RTFCONVEXW, RtfconvExW ) ;
CONV_LOAD_GLOBAL ( ABORTRTFCONV, AbortRtfconv ) ;
#ifdef RTFCONV_COM
CONV_LOAD_GLOBAL ( GETDLLVERSION, GetDllVersion ) ;
#endif

#ifdef __cplusplus
}
#endif



#endif // end of #if defined RTFCONV_EXE || defined RTFCONV_COM



////////////////////////////////////////
//          CHNCONV.EXE/COM           //
////////////////////////////////////////
#if defined CHNCONV_EXE || defined CHNCONV_COM



#include "chnconv.h"


#ifdef __cplusplus
extern "C" {
#endif

int LoadChnconvDll ( void ) ;

CONV_LOAD_GLOBAL ( HINSTANCE, hChnconv ) ;

CONV_LOAD_GLOBAL ( CHNCONVEXA, ChnconvExA ) ;
CONV_LOAD_GLOBAL ( CHNCONVEXW, ChnconvExW ) ;
CONV_LOAD_GLOBAL ( ABORTCHNCONV, AbortChnconv ) ;
CONV_LOAD_GLOBAL ( GETDLLVERSION, GetDllVersion ) ;

#ifdef __cplusplus
}
#endif



#endif // end of #if defined CHNCONV_EXE || defined CHNCONV_COM



#endif
