// filename.cpp

#include <windows.h>
#include <string.h>
#include <ctype.h>
#include <mbctype.h>
#include "msc.h"

#undef DEBUG_CONST_STRING
#include "filename.h"



////////////////////////////////////////////
//              gq擾              //
////////////////////////////////////////////



// pXgqiANSIŁj
// gq '.' ܂܂Ȃ
// Ȃ NULL Ԃ
char *GetExtensionA ( const char *szPathName ) {

   const char *szExtension = NULL ;

   for ( const char *szString = szPathName ; *szString ; szString ++ ) {
      if ( *szString == '.' ) szExtension = szString + 1 ;
      if ( IsPathOrDriveSeparator ( *szString ) ) szExtension = NULL ;
      if ( ismbblead ( (unsigned char) *szString ) && *( szString + 1 ) ) szString ++ ;
   }

   return (char*) szExtension ;
}



// pXgqiUNICODEŁj
// gq '.' ܂܂Ȃ
// Ȃ NULL Ԃ
wchar_t *GetExtensionW ( const wchar_t *szPathName ) {

   const wchar_t *szExtension = NULL ;

   for ( const wchar_t *szString = szPathName ; *szString ; szString ++ ) {
      if ( *szString == '.' ) szExtension = szString + 1 ;
      if ( IsPathOrDriveSeparator ( *szString ) ) szExtension = NULL ;
   }

   return (wchar_t*) szExtension ;
}



////////////////////////////////////////////
//              gqύX              //
////////////////////////////////////////////



// pX̊gqύXiANSIŁj
// gq '.' ܂܂Ȃ
// gq NULL w肷ƁAgq폜
// pXԂ
char *ChangeExtensionA ( char *szPathName, const char *szExtension ) {

   char *szString = GetExtensionA ( szPathName ) ;

   if ( szString ) {
      if ( szExtension ) strcpy ( szString, szExtension ) ;
      else               *( szString - 1 ) = 0 ;
   }
   else {
      if ( szExtension ) {
         szString = strend ( szPathName ) ;
         *szString = '.' ;
         strcpy ( szString + 1, szExtension ) ;
      }
   }

   return szPathName ;
}



// pX̊gqύXiUNICODEŁj
// gq '.' ܂܂Ȃ
// gq NULL w肷ƁAgq폜
// pXԂ
wchar_t *ChangeExtensionW ( wchar_t *szPathName, const wchar_t *szExtension ) {

   wchar_t *szString = GetExtensionW ( szPathName ) ;

   if ( szString ) {
      if ( szExtension ) wcscpy ( szString, szExtension ) ;
      else               *( szString - 1 ) = 0 ;
   }
   else {
      if ( szExtension ) {
         szString = wcsend ( szPathName ) ;
         *szString = '.' ;
         wcscpy ( szString + 1, szExtension ) ;
      }
   }

   return szPathName ;
}



////////////////////////////////////////////
//            t@C擾            //
////////////////////////////////////////////



// pXt@CiANSIŁj
// Ȃ NULL Ԃ
char *GetFileNameA ( const char *szPathName ) {

   for ( const char *szString = szPathName ; *szString ; szString ++ ) {
      if ( IsPathOrDriveSeparator ( *szString ) ) szPathName = szString + 1 ;
      if ( ismbblead ( (unsigned char) *szString ) && *( szString + 1 ) ) szString ++ ;
   }

   if ( ! *szPathName ) szPathName = NULL ;

   return (char*) szPathName ;
}



// pXt@CiUNICODEŁj
// Ȃ NULL Ԃ
wchar_t *GetFileNameW ( const wchar_t *szPathName ) {

   for ( const wchar_t *szString = szPathName ; *szString ; szString ++ ) {
      if ( IsPathOrDriveSeparator ( *szString ) ) szPathName = szString + 1 ;
   }

   if ( ! *szPathName ) szPathName = NULL ;

   return (wchar_t*) szPathName ;
}



////////////////////////////////////////////
//            t@CύX            //
////////////////////////////////////////////



// pX̃t@CύXiANSIŁj
// t@C NULL w肷ƁAt@C폜
// pXԂ
char *ChangeFileNameA ( char *szPathName, const char *szFileName ) {

   char *szString = GetFileNameA ( szPathName ) ;
   if ( ! szString ) szString = strend ( szPathName ) ;

   if ( ! szFileName ) szFileName = "" ;
   strcpy ( szString, szFileName ) ;

   return szPathName ;
}



// pX̃t@CύXiUNICODEŁj
// t@C NULL w肷ƁAt@C폜
// pXԂ
wchar_t *ChangeFileNameW ( wchar_t *szPathName, const wchar_t *szFileName ) {

   wchar_t *szString = GetFileNameW ( szPathName ) ;
   if ( ! szString ) szString = wcsend ( szPathName ) ;

   if ( ! szFileName ) szFileName = L"" ;
   wcscpy ( szString, szFileName ) ;

   return szPathName ;
}



////////////////////////////////////////////
//        t@Cɕt        //
////////////////////////////////////////////



// pX̃t@CɕtiANSIŁj
// gq΁Agq̑Oɕt
// pXԂ
char *AddToFileNameA ( char *szPathName, const char *szString ) {

   if ( ! szString || ! *szString ) return szPathName ;

   char *szExtension = GetExtensionA ( szPathName ) ;

   char *szEnd ;
   if ( szExtension ) szEnd = szExtension - 1 ;
   else               szEnd = strend ( szPathName ) ;

   size_t nLength = strlen ( szString ) ;

   memmove ( szEnd + nLength, szEnd, ( strlen ( szEnd ) + 1 ) * sizeof(char) ) ;
   memmove ( szEnd, szString, nLength * sizeof(char) ) ;

   return szPathName ;
}



// pX̃t@CɕtiUNICODEŁj
// gq΁Agq̑Oɕt
// pXԂ
wchar_t *AddToFileNameW ( wchar_t *szPathName, const wchar_t *szString ) {

   if ( ! szString || ! *szString ) return szPathName ;

   wchar_t *szExtension = GetExtensionW ( szPathName ) ;

   wchar_t *szEnd ;
   if ( szExtension ) szEnd = szExtension - 1 ;
   else               szEnd = wcsend ( szPathName ) ;

   size_t nLength = wcslen ( szString ) ;

   memmove ( szEnd + nLength, szEnd, ( wcslen ( szEnd ) + 1 ) * sizeof(wchar_t) ) ;
   memmove ( szEnd, szString, nLength * sizeof(wchar_t) ) ;

   return szPathName ;
}



////////////////////////////////////////////
//            tpX擾            //
////////////////////////////////////////////



// tpX擾iANSIŁj
// o͂̒ԂiI[k܂ށj
// s 0 Ԃ
size_t GetFullPathNameExA ( const char *szSrcFileName, char *szDstFileName, size_t nMaxLen ) {

   char *szFilePart ;

   if ( nMaxLen > MAX_PATH ) nMaxLen = MAX_PATH ;
   if ( ! szDstFileName ) nMaxLen = 0 ;

   size_t nResult = GetFullPathNameA ( szSrcFileName, (unsigned long) nMaxLen, szDstFileName, & szFilePart ) ;
   if ( nResult > nMaxLen ) nResult = 0 ;

   return nResult ;
}



// tpX擾iUNICODEŁj
// o͂̒ԂiI[k܂ށj
// s 0 Ԃ
size_t GetFullPathNameExW ( const wchar_t *szSrcFileName, wchar_t *szDstFileName, size_t nMaxLen ) {

   wchar_t *szFilePart ;

   if ( nMaxLen > MAX_LONG_PATH ) nMaxLen = MAX_LONG_PATH ;
   if ( ! szDstFileName ) nMaxLen = 0 ;

   size_t nResult = GetFullPathNameW ( szSrcFileName, (unsigned long) nMaxLen, szDstFileName, & szFilePart ) ;
   if ( nResult > nMaxLen ) nResult = 0 ;

   return nResult ;
}



// tpX擾ĕiANSIŁj
// free() gĉ邱
// s NULL Ԃ
char *GetFullPathNameAllocA ( const char *szFileName ) {

   char *szResult = NULL ;
   char *szFilePart ;
   unsigned long nLength ;
   unsigned long nResult ;

   if ( strlen ( szFileName ) + 1 > MAX_PATH ) return NULL ;

   if ( ! ( nLength = GetFullPathNameA ( szFileName, 0, NULL, & szFilePart ) ) ) goto CAUGHT_ERROR ;
   nLength += 8 ;       // GetFullPathName() ̓t@CP̂Ƃ]TKv
   if ( ! ( szResult = (char*) malloc ( nLength * sizeof(char) ) ) ) goto CAUGHT_ERROR ;
   if ( ! ( nResult = GetFullPathNameA ( szFileName, nLength, szResult, & szFilePart ) ) || nResult >= nLength ) goto CAUGHT_ERROR ;

   return szResult ;

   CAUGHT_ERROR :
   free ( szResult ) ;
   return NULL ;
}



// tpX擾ĕiUNICODEŁj
// free() gĉ邱
// s NULL Ԃ
wchar_t *GetFullPathNameAllocW ( const wchar_t *szFileName ) {

   wchar_t *szResult = NULL ;
   wchar_t *szFilePart ;
   unsigned long nLength ;
   unsigned long nResult ;

   if ( wcslen ( szFileName ) + 1 > MAX_LONG_PATH ) return NULL ;

   if ( ! ( nLength = GetFullPathNameW ( szFileName, 0, NULL, & szFilePart ) ) ) goto CAUGHT_ERROR ;
   nLength += 8 ;       // GetFullPathName() ̓t@CP̂Ƃ]TKv
   if ( ! ( szResult = (wchar_t*) malloc ( nLength * sizeof(wchar_t) ) ) ) goto CAUGHT_ERROR ;
   if ( ! ( nResult = GetFullPathNameW ( szFileName, nLength, szResult, & szFilePart ) ) || nResult >= nLength ) goto CAUGHT_ERROR ;

   return szResult ;

   CAUGHT_ERROR :
   free ( szResult ) ;
   return NULL ;
}



////////////////////////////////////////////
//            tpX            //
////////////////////////////////////////////



// tpXiUNC܂ށjiANSIŁj
int IsFullPathNameA ( const char *szPathName ) {

   if ( isascii ( *szPathName ) && isalpha ( *szPathName ) ) {
      if ( *( szPathName + 1 ) == ':' && IsPathSeparator ( *( szPathName + 2 ) ) ) return 1 ;
   }

   if ( *szPathName == '\\' && *( szPathName + 1 ) == '\\' ) return 1 ;

   return 0 ;
}



// tpXiUNC܂ށjiUNICODEŁj
int IsFullPathNameW ( const wchar_t *szPathName ) {

   if ( isascii ( *szPathName ) && isalpha ( *szPathName ) ) {
      if ( *( szPathName + 1 ) == ':' && IsPathSeparator ( *( szPathName + 2 ) ) ) return 1 ;
   }

   if ( *szPathName == '\\' && *( szPathName + 1 ) == '\\' ) return 1 ;

   return 0 ;
}



////////////////////////////////////////////
//               UNC                //
////////////////////////////////////////////



// UNCiANSIŁj
int IsFileNameUncA ( const char *szPathName ) {

   if ( *szPathName == '\\' && *( szPathName + 1 ) == '\\' ) return 1 ;

   return 0 ;
}



// UNCiUNICODEŁj
int IsFileNameUncW ( const wchar_t *szPathName ) {

   if ( *szPathName == '\\' && *( szPathName + 1 ) == '\\' ) return 1 ;

   return 0 ;
}



////////////////////////////////////////////
//               URL                //
////////////////////////////////////////////



// URLiANSIŁj
int IsFileNameUrlA ( const char *szPathName ) {

   const char *szString = szPathName ;
   while ( isascii ( *szString ) && isalpha ( *szString ) ) szString ++ ;
   if ( *szString == ':' && IsPathSeparator ( *( szString + 1 ) ) && szString - szPathName > 1 ) return 1 ;

   return 0 ;
}



// URLiUNICODEŁj
int IsFileNameUrlW ( const wchar_t *szPathName ) {

   const wchar_t *szString = szPathName ;
   while ( isascii ( *szString ) && isalpha ( *szString ) ) szString ++ ;
   if ( *szString == ':' && IsPathSeparator ( *( szString + 1 ) ) && szString - szPathName > 1 ) return 1 ;

   return 0 ;
}



////////////////////////////////////////////
//            pX𒲐            //
////////////////////////////////////////////



static inline int strheadcmp ( const char *string, const char *head ) ;
static inline int wcsheadcmp ( const wchar_t *string, const wchar_t *head ) ;



// pX̖ \ 𒲐iANSIŁj
//  IsAddSeparator  REMOVE_SEPARATOR_ALWAYS Ȃ \ 
//  IsAddSeparator  ADD_SEPARATOR_ALWAYS Ȃ \ t
//  IsAddSeparator  ADD_SEPARATOR_ONLY_ROOT Ȃ΃[gfBNĝ \ t
// pXԂ
char *SetPathSeparatorA ( char *szPathName, int IsAddSeparator ) {

   for ( char *szString = szPathName ; *szString ; szString ++ ) {
      if ( IsPathSeparator ( *szString ) && *( szString + 1 ) == 0 ) {
         *szString = 0 ;
         break ;
      }
      if ( ismbblead ( (unsigned char) *szString ) && *( szString + 1 ) ) szString ++ ;
   }

   if ( IsAddSeparator == ADD_SEPARATOR_ONLY_ROOT ) {

      char *szStart = szPathName ;

      static const char szLongPathHead [] = "\\\\?\\" ;     // for "\\?\C:\<path>", "\\?\UNC\<server>\<share>"
      if ( ! strheadcmp ( szStart, szLongPathHead ) ) szStart += strlen ( szLongPathHead ) ;

      if ( ! *szStart || isascii ( *szStart ) && isalpha ( *szStart ) && *( szStart + 1 ) == ':' && *( szStart + 2 ) == 0 ) IsAddSeparator = ADD_SEPARATOR_ALWAYS ;
   }

   if ( IsAddSeparator == ADD_SEPARATOR_ALWAYS ) strcat ( szPathName, "\\" ) ;

   return szPathName ;
}



// pX̖ \ 𒲐iUNICODEŁj
//  IsAddSeparator  REMOVE_SEPARATOR_ALWAYS Ȃ \ 
//  IsAddSeparator  ADD_SEPARATOR_ALWAYS Ȃ \ t
//  IsAddSeparator  ADD_SEPARATOR_ONLY_ROOT Ȃ΃[gfBNĝ \ t
// pXԂ
wchar_t *SetPathSeparatorW ( wchar_t *szPathName, int IsAddSeparator ) {

   for ( wchar_t *szString = szPathName ; *szString ; szString ++ ) {
      if ( IsPathSeparator ( *szString ) && *( szString + 1 ) == 0 ) {
         *szString = 0 ;
         break ;
      }
   }

   if ( IsAddSeparator == ADD_SEPARATOR_ONLY_ROOT ) {

      wchar_t *szStart = szPathName ;

      static const wchar_t szLongPathHead [] = L"\\\\?\\" ;    // for "\\?\C:\<path>", "\\?\UNC\<server>\<share>"
      if ( ! wcsheadcmp ( szStart, szLongPathHead ) ) szStart += wcslen ( szLongPathHead ) ;

      if ( ! *szStart || isascii ( *szStart ) && isalpha ( *szStart ) && *( szStart + 1 ) == ':' && *( szStart + 2 ) == 0 ) IsAddSeparator = ADD_SEPARATOR_ALWAYS ;
   }

   if ( IsAddSeparator == ADD_SEPARATOR_ALWAYS ) wcscat ( szPathName, L"\\" ) ;

   return szPathName ;
}



// ̐擪riANSIŁj
static inline int strheadcmp ( const char *string, const char *head ) {
   return strncmp ( string, head, strlen ( head ) ) ;
}



// ̐擪riUNICODEŁj
static inline int wcsheadcmp ( const wchar_t *string, const wchar_t *head ) {
   return wcsncmp ( string, head, wcslen ( head ) ) ;
}



////////////////////////////////////////////
//            dpt            //
////////////////////////////////////////////



// 󔒂Γdpň͂ށiANSIŁj
char *QuoteFileNameA ( char *szPathName ) {

   if ( strpbrk ( szPathName, " ,;=&\t" ) ) {
      size_t nLength = strlen ( szPathName ) ;
      memmove ( szPathName + 1, szPathName, ( nLength + 1 ) * sizeof(char) ) ;
      *szPathName = '\"' ;
      *( szPathName + nLength + 1 ) = '\"' ;
      *( szPathName + nLength + 2 ) = 0 ;
   }

   return szPathName ;
}



// 󔒂Γdpň͂ށiUNICODEŁj
wchar_t *QuoteFileNameW ( wchar_t *szPathName ) {

   if ( wcspbrk ( szPathName, L" ,;=&\t" ) ) {
      size_t nLength = wcslen ( szPathName ) ;
      memmove ( szPathName + 1, szPathName, ( nLength + 1 ) * sizeof(wchar_t) ) ;
      *szPathName = '\"' ;
      *( szPathName + nLength + 1 ) = '\"' ;
      *( szPathName + nLength + 2 ) = 0 ;
   }

   return szPathName ;
}



////////////////////////////////////////////
//            dp폜            //
////////////////////////////////////////////



// dpɈ͂܂ꂽt@Cdp菜iANSIŁj
char *UnquoteFileNameA ( char *szPathName ) {

   if ( *szPathName == '\"' ) {
      size_t nLength = strlen ( szPathName + 1 ) ;
      memmove ( szPathName, szPathName + 1, ( nLength + 1 ) * sizeof(char) ) ;
      if ( *( szPathName + nLength - 1 ) == '\"' ) *( szPathName + nLength - 1 ) = 0 ;
   }

   return szPathName ;
}



// dpɈ͂܂ꂽt@Cdp菜iUNICODEŁj
wchar_t *UnquoteFileNameW ( wchar_t *szPathName ) {

   if ( *szPathName == '\"' ) {
      size_t nLength = wcslen ( szPathName + 1 ) ;
      memmove ( szPathName, szPathName + 1, ( nLength + 1 ) * sizeof(wchar_t) ) ;
      if ( *( szPathName + nLength - 1 ) == '\"' ) *( szPathName + nLength - 1 ) = 0 ;
   }

   return szPathName ;
}



