// guifont.h

#ifndef GUIFONT_H
#define GUIFONT_H

#ifdef __cplusplus
extern "C" {
#endif


int GetDesktopFontA ( char *szFontName, int *pHeight ) ;
int GetDesktopFontW ( wchar_t *szFontName, int *pHeight ) ;

HFONT CreateFontByCodePage ( int nSize, int nCodePage ) ;
HFONT CreateGuiFont ( int nSize ) ;
HFONT CreateVistaGuiFont ( int nSize ) ;


#ifdef UNICODE
#define GetDesktopFont GetDesktopFontW
#else
#define GetDesktopFont GetDesktopFontA
#endif


#ifdef __cplusplus
}
#endif

#endif


