// shfileop.cpp

#include <windows.h>
#include <stdlib.h>
#include <string.h>
#include "msc.h"
#include "shfileop.h"



//////////////////////////////
//          ANSI          //
//////////////////////////////



// VF𗘗pĕ̃t@C폜iANSIŁj
// 폜ꂽt@C͂ݔֈړ
// Ŏw肳镶ɂ́AɌ'\0'
// t@C̓ChJ[hgp
// t@C̓tpXŎw
// hWnd  NULL w肷ƁAvOX_CAO\Ȃ
//  0 As炻ȊOԂ
int ShellDeleteMultipleFilesA ( HWND hWnd, const char *szFileNameBuffer, int IsNoRecycleBin ) {

   if ( ! szFileNameBuffer ) return 1 ;

   SHFILEOPSTRUCTA ShFileOp = { 0 } ;
   ShFileOp.hwnd = hWnd ;
   ShFileOp.wFunc = FO_DELETE ;
   ShFileOp.pFrom = szFileNameBuffer ;
   ShFileOp.fFlags = FOF_NOCONFIRMATION | FOF_NOERRORUI | ( ( hWnd ) ? 0 : FOF_SILENT ) | ( ( IsNoRecycleBin ) ? 0 : FOF_ALLOWUNDO ) ;

   return SHFileOperationA ( & ShFileOp ) || ShFileOp.fAnyOperationsAborted ;
}



// VF𗘗pĂP̃t@C폜iANSIŁj
// 폜ꂽt@C͂ݔֈړ
// t@C̓ChJ[hgp
// t@C̓tpXŎw
// hWnd  NULL w肷ƁAvOX_CAO\Ȃ
//  0 As炻ȊOԂ
int ShellDeleteFileA ( HWND hWnd, const char *szFileName, int IsNoRecycleBin ) {

   if ( ! szFileName ) return 1 ;

   char *szFileNameBuffer = strdup_expand ( szFileName, MAX_PATH, 1 ) ; //  0 t邽
   if ( ! szFileNameBuffer ) return 1 ;

   *( strend ( szFileNameBuffer ) + 1 ) = 0 ;

   int nResult = ShellDeleteMultipleFilesA ( hWnd, szFileNameBuffer, IsNoRecycleBin ) ;

   free ( szFileNameBuffer ) ;
   return nResult ;
}



// VF𗘗pĕ̃t@CRs[EړiANSIŁj
// Ŏw肳镶ɂ́AɌ'\0'
// t@C̓ChJ[hgp
// t@C̓tpXŎw
// szDstDir ɂ \ ŏItH_w
// hWnd  NULL w肷ƁAvOX_CAO\Ȃ
//  0 As炻ȊOԂ
int ShellCopyMultipleFilesA ( HWND hWnd, const char *szFileNameBuffer, const char *szDstDir, int IsMove ) {

   if ( ! szFileNameBuffer ) return 1 ;
   if ( ! szDstDir ) return 1 ;

   SHFILEOPSTRUCTA ShFileOp = { 0 } ;
   ShFileOp.hwnd = hWnd ;
   ShFileOp.wFunc = ( IsMove ) ? FO_MOVE : FO_COPY ;
   ShFileOp.pFrom = szFileNameBuffer ;
   ShFileOp.pTo = szDstDir ;
   ShFileOp.fFlags = FOF_NOCONFIRMATION | FOF_NOERRORUI | ( ( hWnd ) ? 0 : FOF_SILENT ) | FOF_NOCONFIRMMKDIR ;

   return SHFileOperationA ( & ShFileOp ) || ShFileOp.fAnyOperationsAborted ;
}



// VF𗘗pĂP̃t@CRs[EړiANSIŁj
// t@C̓ChJ[hgp
// t@C̓tpXŎw
// szDstDir ɂ \ ŏItH_w
// hWnd  NULL w肷ƁAvOX_CAO\Ȃ
//  0 As炻ȊOԂ
int ShellCopyFileA ( HWND hWnd, const char *szFileName, const char *szDstDir, int IsMove ) {

   if ( ! szFileName ) return 1 ;

   char *szFileNameBuffer = strdup_expand ( szFileName, MAX_PATH, 1 ) ; //  0 t邽
   if ( ! szFileNameBuffer ) return 1 ;

   *( strend ( szFileNameBuffer ) + 1 ) = 0 ;

   int nResult = ShellCopyMultipleFilesA ( hWnd, szFileNameBuffer, szDstDir, IsMove ) ;

   free ( szFileNameBuffer ) ;
   return nResult ;
}



//////////////////////////////
//         UNICODE        //
//////////////////////////////



#ifndef NTFUNC_IMPORT_IMPLICITLY
#define SHFileOperationW SHFileOperationW_
static int WINAPI SHFileOperationW ( LPSHFILEOPSTRUCTW lpFileOp ) ;
#endif



// VF𗘗pĕ̃t@C폜iUNICODEŁj
// 폜ꂽt@C͂ݔֈړ
// Ŏw肳镶ɂ́AɌ'\0'
// t@C̓tpXŎw
// hWnd  NULL w肷ƁAvOX_CAO\Ȃ
//  0 As炻ȊOԂ
int ShellDeleteMultipleFilesW ( HWND hWnd, const wchar_t *szFileNameBuffer, int IsNoRecycleBin ) {

   if ( ! szFileNameBuffer ) return 1 ;

   SHFILEOPSTRUCTW ShFileOp = { 0 } ;
   ShFileOp.hwnd = hWnd ;
   ShFileOp.wFunc = FO_DELETE ;
   ShFileOp.pFrom = szFileNameBuffer ;
   ShFileOp.fFlags = FOF_NOCONFIRMATION | FOF_NOERRORUI | ( ( hWnd ) ? 0 : FOF_SILENT ) | ( ( IsNoRecycleBin ) ? 0 : FOF_ALLOWUNDO ) ;

   return SHFileOperationW ( & ShFileOp ) || ShFileOp.fAnyOperationsAborted ;
}



// VF𗘗pĂP̃t@C폜iUNICODEŁj
// 폜ꂽt@C͂ݔֈړ
// t@C̓tpXŎw
// hWnd  NULL w肷ƁAvOX_CAO\Ȃ
//  0 As炻ȊOԂ
int ShellDeleteFileW ( HWND hWnd, const wchar_t *szFileName, int IsNoRecycleBin ) {

   if ( ! szFileName ) return 1 ;

   wchar_t *szFileNameBuffer = wcsdup_expand ( szFileName, MAX_LONG_PATH, 1 ) ;  //  0 t邽
   if ( ! szFileNameBuffer ) return 1 ;

   *( wcsend ( szFileNameBuffer ) + 1 ) = 0 ;

   int nResult = ShellDeleteMultipleFilesW ( hWnd, szFileNameBuffer, IsNoRecycleBin ) ;

   free ( szFileNameBuffer ) ;
   return nResult ;
}



// VF𗘗pĕ̃t@CRs[EړiANSIŁj
// Ŏw肳镶ɂ́AɌ'\0'
// t@C̓ChJ[hgp
// t@C̓tpXŎw
// szDstDir ɂ \ ŏItH_w
// hWnd  NULL w肷ƁAvOX_CAO\Ȃ
//  0 As炻ȊOԂ
int ShellCopyMultipleFilesW ( HWND hWnd, const wchar_t *szFileNameBuffer, const wchar_t *szDstDir, int IsMove ) {

   if ( ! szFileNameBuffer ) return 1 ;
   if ( ! szDstDir ) return 1 ;

   SHFILEOPSTRUCTW ShFileOp = { 0 } ;
   ShFileOp.hwnd = hWnd ;
   ShFileOp.wFunc = ( IsMove ) ? FO_MOVE : FO_COPY ;
   ShFileOp.pFrom = szFileNameBuffer ;
   ShFileOp.pTo = szDstDir ;
   ShFileOp.fFlags = FOF_NOCONFIRMATION | FOF_NOERRORUI | ( ( hWnd ) ? 0 : FOF_SILENT ) | FOF_NOCONFIRMMKDIR ;

   return SHFileOperationW ( & ShFileOp ) || ShFileOp.fAnyOperationsAborted ;
}



// VF𗘗pĂP̃t@CRs[EړiANSIŁj
// t@C̓ChJ[hgp
// t@C̓tpXŎw
// szDstDir ɂ \ ŏItH_w
// hWnd  NULL w肷ƁAvOX_CAO\Ȃ
//  0 As炻ȊOԂ
int ShellCopyFileW ( HWND hWnd, const wchar_t *szFileName, const wchar_t *szDstDir, int IsMove ) {

   if ( ! szFileName ) return 1 ;

   wchar_t *szFileNameBuffer = wcsdup_expand ( szFileName, MAX_LONG_PATH, 1 ) ;  //  0 t邽
   if ( ! szFileNameBuffer ) return 1 ;

   *( wcsend ( szFileNameBuffer ) + 1 ) = 0 ;

   int nResult = ShellCopyMultipleFilesW ( hWnd, szFileNameBuffer, szDstDir, IsMove ) ;

   free ( szFileNameBuffer ) ;
   return nResult ;
}



//////////////////////////////
//       NT FUNCTIONS       //
//////////////////////////////



#ifndef NTFUNC_IMPORT_IMPLICITLY



#define SHFileOperationW SHFileOperationW_
typedef int ( WINAPI *SHFILEOPERATIONW ) ( LPSHFILEOPSTRUCTW lpFileOp ) ;
static HINSTANCE hShell32 ;
static int FreeLibraryOnDetach ( void ) ;



static int WINAPI SHFileOperationW ( LPSHFILEOPSTRUCTW lpFileOp ) {
#undef SHFileOperationW

   static SHFILEOPERATIONW SHFileOperationW ;
   static volatile int IsTried ;

   if ( ! IsTried ) {
#ifdef _MT
      EnterCriticalSection ( & LoadDllSection ) ;
      __try {
         if ( ! IsTried ) {
#endif
            if ( ! hShell32 && ( hShell32 = LoadLibraryW ( L"SHELL32.DLL" ) ) ) FreeLibraryOnDetach () ;
            GETPROCADDRESS ( hShell32, SHFILEOPERATIONW, SHFileOperationW ) ;
            IsTried = 1 ;
#ifdef _MT
         }
      } __finally {
         LeaveCriticalSection ( & LoadDllSection ) ;
      }
#endif
   }
   if ( ! SHFileOperationW ) return TRUE ;

   return SHFileOperationW ( lpFileOp ) ;
}



static void __cdecl ExitProc ( void ) {
   if ( hShell32 ) FreeLibrary ( hShell32 ) ;
}



static int FreeLibraryOnDetach ( void ) {
#ifdef _USRDLL
   return atexit ( ExitProc ) ;
#else
   return 0 ;
#endif
}



#endif // ! NTFUNC_IMPORT_IMPLICITLY



