// shfileop.h

#ifndef SHFILEOP_H
#define SHFILEOP_H

#ifdef __cplusplus
extern "C" {
#endif


int ShellDeleteMultipleFilesA ( HWND hWnd, const char *szFileNameBuffer, int IsNoRecycleBin ) ;
int ShellDeleteFileA ( HWND hWnd, const char *szFileName, int IsNoRecycleBin ) ;
int ShellDeleteMultipleFilesW ( HWND hWnd, const wchar_t *szFileNameBuffer, int IsNoRecycleBin ) ;
int ShellDeleteFileW ( HWND hWnd, const wchar_t *szFileName, int IsNoRecycleBin ) ;

int ShellCopyMultipleFilesA ( HWND hWnd, const char *szFileNameBuffer, const char *szDstDir, int IsMove ) ;
int ShellCopyFileA ( HWND hWnd, const char *szFileName, const char *szDstDir, int IsMove ) ;
int ShellCopyMultipleFilesW ( HWND hWnd, const wchar_t *szFileNameBuffer, const wchar_t *szDstDir, int IsMove ) ;
int ShellCopyFileW ( HWND hWnd, const wchar_t *szFileName, const wchar_t *szDstDir, int IsMove ) ;


#ifdef UNICODE
#define ShellDeleteMultipleFiles ShellDeleteMultipleFilesW
#define ShellDeleteFile ShellDeleteFileW
#define ShellCopyMultipleFiles ShellCopyMultipleFilesW
#define ShellCopyFile ShellCopyFileW
#else
#define ShellDeleteMultipleFiles ShellDeleteMultipleFilesA
#define ShellDeleteFile ShellDeleteFileA
#define ShellCopyMultipleFiles ShellCopyMultipleFilesA
#define ShellCopyFile ShellCopyFileA
#endif


#ifdef __cplusplus
}
#endif

#endif


